// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*! 
 * @file Duration.c
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#include "Duration.h"

#include <ucdr/microcdr.h>
#include <string.h>

bool Duration_serialize_topic(ucdrBuffer* writer, const Duration* topic)
{
    (void) ucdr_serialize_int32_t(writer, topic->sec_);

    (void) ucdr_serialize_uint32_t(writer, topic->nanosec_);

    return !writer->error;
}

bool Duration_deserialize_topic(ucdrBuffer* reader, Duration* topic)
{
    (void) ucdr_deserialize_int32_t(reader, &topic->sec_);

    (void) ucdr_deserialize_uint32_t(reader, &topic->nanosec_);

    return !reader->error;
}

uint32_t Duration_size_of_topic(const Duration* topic, uint32_t size)
{
    uint32_t previousSize = size;
    size += ucdr_alignment(size, 4) + 4;

    size += ucdr_alignment(size, 4) + 4;

    return size - previousSize;
}
