// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*! 
 * @file Joy.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _Joy_H_
#define _Joy_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdint.h>
#include <stdbool.h>
#include "Header.h"

/*!
 * @brief This struct represents the structure Joy defined by the user in the IDL file.
 * @ingroup JOY
 */
typedef struct Joy
{
    Header header;
    uint32_t axes_size;
    float axes[8];
    uint32_t buttons_size;
    int32_t buttons[11];
} Joy;

struct ucdrBuffer;

bool Joy_serialize_topic(struct ucdrBuffer* writer, const Joy* topic);
bool Joy_deserialize_topic(struct ucdrBuffer* reader, Joy* topic);
uint32_t Joy_size_of_topic(const Joy* topic, uint32_t size);


#ifdef __cplusplus
}
#endif

#endif // _Joy_H_