// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*! 
 * @file Vector3.c
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#include "Vector3.h"

#include <ucdr/microcdr.h>
#include <string.h>

bool Vector3_serialize_topic(ucdrBuffer* writer, const Vector3* topic)
{
    (void) ucdr_serialize_double(writer, topic->x);

    (void) ucdr_serialize_double(writer, topic->y);

    (void) ucdr_serialize_double(writer, topic->z);

    return !writer->error;
}

bool Vector3_deserialize_topic(ucdrBuffer* reader, Vector3* topic)
{
    (void) ucdr_deserialize_double(reader, &topic->x);

    (void) ucdr_deserialize_double(reader, &topic->y);

    (void) ucdr_deserialize_double(reader, &topic->z);

    return !reader->error;
}

uint32_t Vector3_size_of_topic(const Vector3* topic, uint32_t size)
{
    uint32_t previousSize = size;
    size += ucdr_alignment(size, 8) + 8;

    size += ucdr_alignment(size, 8) + 8;

    size += ucdr_alignment(size, 8) + 8;

    return size - previousSize;
}
